function RBH_OnLoad(self)
    self:RegisterEvent("VARIABLES_LOADED"); 	
    self:RegisterEvent("PLAYER_LOGIN");
    self:RegisterEvent("PLAYER_LOGOUT");
    self:RegisterEvent("PLAYER_ENTERING_WORLD");	
    self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
    self:RegisterEvent("CHAT_MSG_SYSTEM");
    self:RegisterEvent("CHAT_MSG_ADDON");
    self:RegisterEvent("WHO_LIST_UPDATE");
    self:RegisterEvent("CHAT_MSG_CHANNEL")
    self:RegisterEvent("CHAT_MSG_CHANNEL_JOIN")
    self:RegisterEvent("CHAT_MSG_CHANNEL_LEAVE")
    self:RegisterEvent("PLAYER_MONEY")
    self:RegisterEvent("GUILD_ROSTER_UPDATE")
    RegisterAddonMessagePrefix("RBH_HL_SYNC_REQ")   
    RegisterAddonMessagePrefix("RBH_HL_UPDATE")   
    RegisterAddonMessagePrefix("RBH_HL_CLEAR")  
    RegisterAddonMessagePrefix("RBH_USERS_REQ")
    RegisterAddonMessagePrefix("RBH_USERS_ACK")  
    RegisterAddonMessagePrefix("RBH_ADDME_REQ")
    
end

function RBH_OnEvent(self, event, ...)    
    local arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9 = ...;
    ---print("Event: "..event..", arg2: "..arg2..", arg5: "..arg5..", arg9: "..arg9)
    if event == "VARIABLES_LOADED" then 
        RBH_HitListFrame:RegisterForDrag("LeftButton")        
        RBH_Init() 
        
    elseif (event == "PLAYER_LOGIN") then
        RBH_LargessMessage("[RBH] Realm Bounty Hunter v"..RBH_VERSION.." loaded", "sys")
        RBH_LargessMessage("[RBH] Type /rbh help for a list of commands", "sys") 
        RBH_Largess = GetMoney() - RBH_GetTotalIssuedBountiesValue()
        RBH_CurrMoney = GetMoney()
        
        --init network
        if RBH_Network == nil then
            RBH_Network = {}
        end
        if RBH_Config["RealmChannel"] then
            if RBH_Network[RBH_REALM_CHANNEL] == nil then
                RBH_Network[RBH_REALM_CHANNEL] = {}
            end
        end
        if RBH_Config["PrivateChannel"] then
            if RBH_Network[RBH_PRIVATE_CHANNEL] == nil then
                RBH_Network[RBH_PRIVATE_CHANNEL] = {}
            end
        end     
       
       --join comm channels 
       RBH_ActionQueueAdd([[                   
        if (RBH_Config["RealmChannel"]) then
            JoinPermanentChannel(RBH_REALM_CHANNEL)
        end
       
        if (RBH_Config["PrivateChannel"]) then
            JoinPermanentChannel(RBH_PRIVATE_CHANNEL)		
        end
        ]],10)
        
        --RBH_ActionQueueAdd([[RBH_SendAddonMessageToNetwork("ALERT","RBH","RBH_PING_REQ")]], 15)
        

    
    elseif (event == "GUILD_ROSTER_UPDATE") then
        RBH_GUILD_CHANNEL = GetGuildInfo("player")
        
    elseif (event == "PLAYER_LOGOUT") then
        RBH_Network = nil
    
    elseif (event == "PLAYER_ENTERING_WORLD") then
        RBH_ActionQueueInit()                
        --RBH_SyncNetwork()
        if RBH_Config["scale"] ~= nil then
            RBH_HitListFrame:SetScale(RBH_Config["scale"])
        end   
       
   --check for killing blow      
    elseif (event == "COMBAT_LOG_EVENT_UNFILTERED") and (arg9 ~= UnitName("player")) and arg9 ~= nil then 
		--print(event)
        local n1,n2,destName,destRealm = string.find(arg9,"(.+)-(.+)")
        if destName == nil then
           destName = arg9
           destRealm = GetRealmName()
        end     
      
	    --RBH_LargessMessage("COMBAT_LOG_EVENT_UNFILTERED: "..arg2..", "..arg5)
	  
        if not (arg2 == "PARTY_KILL" or (arg2 == "UNIT_DIED" and (arg5 == UnitName("player") or RBH_IsBountyLocked(destName) and CanEditOfficerNote()))) then
            return
        end        
		
        local audit
        local f, i = IsBountyOpen(destName)  
        
        --RBH_LargessMessage(arg2..": "..destName..":"..i..":"..RBH_HitList[i].state..":"..RBH_HitList[i].class)       
                  
        if (i>0) and (RBH_HitList[i].state == "RBH_OPEN" or RBH_HitList[i].state == "RBH_OPEN_S" or RBH_HitList[i].state == "RBH_OPEN_SL" or RBH_HitList[i].state == "RBH_OPEN_L") then 
           
            if RBH_HitList[i].class == nil then 
                print(RBH_UnitType(arg8))
                if RBH_UnitType(arg8) == 4 then
                    --just killed pet
                    if RBH_HitList[i].class ~= destName then
                        return
                    end
                end
            end 
			
			local claimer = RBH_GetFullName(UnitName("player"))
            --local claimer = UnitName("player");
            local amount = RBH_HitList[i].amount;      
            local j
            local id  = RBH_HitList[i].id
            local timestamp = time()
            local name = RBH_HitList[i].name
            local issuer = RBH_HitList[i].issuer      
            local rname  
        
            --normal behavior (no split)
            RBH_Msg("[RBH] Bounty claimed on {skull} "..destName.." {circle} "..RBH_CopperToGold(amount));                     
            RBH_HitList[i].state = "RBH_CLAIMED"
            RBH_HitList[i].claimer = claimer; 
            RBH_HitList[i].amount = amount
            local id  = RBH_HitList[i].id
            local timestamp = time()
            local name = RBH_HitList[i].name
            local issuer = RBH_HitList[i].issuer              
            if RBH_HitList[i].audit == nil then
               audit = 0
            else
                audit = RBH_HitList[i].audit
            end
            local msg = id..","..time()..","..name..","..issuer..","..amount..","..claimer..","..RBH_HitList[i].state..","..audit;       
            RBH_HitListUpdate()
            RBH_SendAddonMessageToNetwork("ALERT","RBH_HL_UPDATE", msg);        
        end 
    
    --sync
    elseif (event == "CHAT_MSG_ADDON") then       
        --bounty list
        if (arg1 == "RBH_HL_SYNC_REQ") then           
            if arg4 ~= RBH_GetFullName("player") then
                rbh_debug("RBH_HL_SYNC_REQ")
                RBH_HL_DoSync(arg4);          
            end
            
        elseif (arg1 == "RBH_HL_UPDATE") then            
            if arg4 ~= RBH_GetFullName("player") then                
                rbh_debug("RBH_HL_UPDATE")
                RBH_HL_DoUpdate(arg2,arg4);
            end
            
        elseif(arg1 == "RBH_HL_CLEAR") then
            rbh_debug("RBH_HL_CLEAR")
            RBH_HitList = {}
            RBH_HitListUpdate()            
            
        --users request command
        elseif (arg1 == "RBH_USERS_REQ") then
            rbh_debug("RBH_USERS_REQ")           
            ChatThrottleLib:SendAddonMessage("ALERT", "RBH_USERS_ACK", "Realm Bounty Hunter v"..RBH_VERSION, "WHISPER", arg4)
                
        --users response command       
        elseif (arg1 == "RBH_USERS_ACK") then             
            rbh_debug("RBH_USERS_ACK")
            RBH_LargessMessage(arg4..": ".. arg2); 
        
        elseif (arg1 == "RBH_ADDME_REQ") then
            rbh_debug("RBH_ADDME_REQ")
            RBH_AddPlayerToNetwork(arg4, arg2)
            RBH_HL_DoSync(arg4)   
        end  --CHAT_MSG_ADDON   
    
    elseif (event == "CHAT_MSG_CHANNEL_JOIN") then  
        local channelName = string.match(arg4, "%d%.%s(.*)")
        local playerName = RBH_GetFullName(arg2)          
        RBH_AddPlayerToNetwork(playerName, channelName)
        ChatThrottleLib:SendAddonMessage("BULK", "RBH_ADDME_REQ", channelName, "WHISPER", playerName)
        RBH_HL_DoSync(playerName, channelName)
        RBH_LargessMessage(playerName .. " joined channel:"..channelName)
    
    elseif (event == "CHAT_MSG_CHANNEL_LEAVE") then       
        local channelName = string.match(arg4, "%d%.%s(.*)")
        local playerName = RBH_GetFullName(arg2)
        RBH_LargessMessage(playerName .. " left channel:"..channelName)
        RBH_RemovePlayerFromNetwork(playerName, channelName)
    
    elseif (event == "PLAYER_MONEY") then
        if RBH_CurrMoney ~= nil then
            local deltaMoney = GetMoney() - RBH_CurrMoney
            RBH_CurrMoney = GetMoney()
            RBH_Largess = RBH_Largess + deltaMoney
        else
            RBH_CurrMoney = GetMoney()
        end
    
    --intel
    elseif event == "WHO_LIST_UPDATE" then        
        local i,j
        local n = GetNumWhoResults()      
        local pname,prealm = UnitName("player")
        local name, guild, level, race, class, zone
        if RBH_BountySpyCounter ~= nil then
            RBH_BountySpyCounter = RBH_BountySpyCounter + 1        
            if n == 0 then
                RBH_LargessMessage(RBH_BountySpyNames[RBH_BountySpyCounter].name.." could not be found.")
            end
            for i = 1,n do
                name,guild,level,race,class,zone = GetWhoInfo(i)         
                RBH_LargessMessage("Found: "..name.." <"..guild.."> "..tostring(level).." "..race.." "..class.." "..zone)
                for j = 1, #RBH_IntelList do
                    if RBH_IntelList[j].name == name then
                        RBH_IntelList[j].level = tostring(level)
                        RBH_IntelList[j].race = race
                        RBH_IntelList[j].class = class
                        RBH_IntelList[j].zone = zone
                        RBH_IntelList[j].realm = prealm
                        RBH_IntelList[j].intelage = time()
                    end
                end
            end
            if RBH_BountySpyCounter >= RBH_BountySpyCnt then
                RBH_LargessMessage("All guild agents have reported in.")
                FriendsFrame:RegisterEvent("WHO_LIST_UPDATE")
            end  
        end
    end  
end      
  
function RBH_GetFullName(name)
   if name == nil then
        return
   end
   
   if name == "player" then
		name = UnitName("player")
   end
	
   local n, r = string.split("-", name)
   if r ~= nil then
      return name  
      
   else
      local realm = GetRealmName()
      return name.."-"..realm
   end   
   
end

function RBH_UnitIsInMyGuild(name)

	local i
	for i = 1, #RBH_GuildMates do
		if RBH_GuildMates[i].name == name then
			return true
		end
	end
	
	return false
end
	
function RBH_LargessMessage(msg,color)   
   if (color == nil) or (color == "GREEN") or (color == "green") then 
      --default color is green
      DEFAULT_CHAT_FRAME:AddMessage(msg, 0, 1, 0);
   elseif (color == "RED") or (color == "red") then
      --here's red
      DEFAULT_CHAT_FRAME:AddMessage(msg, 1, 0, 0);
   elseif (color == "sys") then
      --yellow?
      DEFAULT_CHAT_FRAME:AddMessage(msg, 1, 1, 0);
   elseif (color == "rep") then
      DEFAULT_CHAT_FRAME:AddMessage(msg, GetMessageTypeColor("CHAT_MSG_COMBAT_FACTION_CHANGE"));
   end   
end